/*
 LibCategory.m
 
 Created by  on 02/03/2014 11:05PM.
 Copyright (c) 2013 . All rights reserved.
 */
#import "LibCategory.h"
@implementation LibCategory
/*init property member var by parsing NSDictionary parameter*/
- (id)initWithDictionary:(NSDictionary *)dictionary{
	if ((self = [super init]) && (dictionary))
	{
        id value ;
        value = dictionary[@"ID"];
        if(value) _ID = [value longValue];  

        value = dictionary[@"name"];
        if(value) _name = value;  

        value = dictionary[@"order"];
        if(value) _order = [value longValue];  

  
    }
    return self;  
}               
- (id)initWithCoder:(NSCoder *)coder{
	if ((self = [super init]))
	{
    	if ([coder allowsKeyedCoding])
	    {
            _ID = [coder decodeIntegerForKey:@"ID"];
            _name = [coder decodeObjectForKey:@"name"];  
            _order = [coder decodeIntegerForKey:@"order"];
        }
        else
        {
            _ID = [[coder decodeObject]longValue];
            _name = [coder decodeObject];  
            _order = [[coder decodeObject]longValue];
        
        }
    }
    return self;
}
- (void)encodeWithCoder:(NSCoder *)coder {
	if ([coder allowsKeyedCoding])
	{
        [coder encodeInt64:_ID forKey:@"ID"];
        if(_name) [coder encodeObject:_name forKey:@"name"];
        [coder encodeInt64:_order forKey:@"order"];
    }
    else
    {
        [coder encodeValueOfObjCType:@encode(long) at:&_ID];
        if(_name) [coder encodeObject:_name];
        [coder encodeValueOfObjCType:@encode(long) at:&_order];
    
    }
}
- (BOOL)isEqual:(LibCategory *)obj {
    if(![obj isKindOfClass:LibCategory.class])
    { 
        return NO;
    }
    return (self.ID==obj.ID)
    && ([self.name isEqual:obj.name])
    && (self.order==obj.order)
    ;
}
- (NSDictionary*)JSONKeyPathsByPropertyKey
{
    return nil;
}
-(BOOL) allowsKeyedCoding
{
    /*[self setValuesForKeysWithDictionary:jsonObject];*/
	return YES;
}
- (id)valueForUndefinedKey:(NSString *)key
{
    // subclass implementation should provide correct key value mappings for custom keys
    NSLog(@"Undefined Key: %@", key);
    return nil;
}

- (void)setValue:(id)value forUndefinedKey:(NSString *)key
{
    // subclass implementation should set the correct key value mappings for custom keys
    NSLog(@"Undefined Key: %@", key);
}
@end
